
#include "ss.h"

int main(void)
{
	MyApp app;
	app.Run();

	return 0;
}

MyApp::MyApp()
	: BApplication(APPLICATION_SIGNATURE)
{
	int x = 223;
	int y = 58;
	int w = 500;
	int h = 400;
	BRect rc(x, y, x+(w-1), y+(h-1));
	fMainWindow = new MainWindow(rc);
}

MainWindow::MainWindow(BRect frame)
	: BWindow(frame, "SS Tester Window", B_TITLED_WINDOW, B_CLOSE_ON_ESCAPE)
{
	CenterOnScreen();
	
	fMainView = new MainView(Bounds());
	fMainView->SetViewColor(B_TRANSPARENT_COLOR);
	AddChild(fMainView);
	
	Show();
}

/*
void c------------------------------() {}
*/
MainView::MainView(BRect rc)
	: BView(rc, "MainView", B_FOLLOW_ALL, B_WILL_DRAW),
	  fNumClicks(0)
{
}


void MainView::Draw(BRect updateRect)
{
bool ss_enabled = true;

	if (Window() && (Window()->Flags() & B_NO_SERVER_SIDE_WINDOW_MODIFIERS))
		ss_enabled = false;
	
	SetHighColor(255, 255, 255);
	
	if (ss_enabled)
	{
		SetLowColor(0, 150, 0);
		FillRect(Bounds(), B_SOLID_LOW);
		
		MovePenTo(16, 16);
		DrawString("B_NO_SERVER_SIDE_WINDOW_MODIFIERS is DISABLED");
		MovePenTo(16, 48);
		DrawString("You can move this window via a CTRL+ALT-click in client area.");
		MovePenTo(16, 65);
		DrawString("But CTRL+ALT+SHIFT-click should NOT move window.");
	}
	else
	{
		SetLowColor(80, 0, 0);
		FillRect(Bounds(), B_SOLID_LOW);
		
		MovePenTo(16, 16);
		DrawString("B_NO_SERVER_SIDE_WINDOW_MODIFIERS is ENABLED");
		MovePenTo(16, 48);
		DrawString("You should NOT be able to move this window via CTRL+ALT-click.");
	}
	
	MovePenTo(16, 100);
	DrawString("To change this behavior, right click inside this window.");
	
	MovePenTo(16, Bounds().bottom - 40);
	char buffer[80];
	sprintf(buffer, "Number of left-clicks seen by application: %d", fNumClicks);
	DrawString(buffer);
	MovePenTo(16, Bounds().bottom - 20);
	DrawString("(use to test whether clicks are being \"eaten\")");
}

void MainView::MouseDown(BPoint where)
{
uint32 buttons;
	LockLooper();

	GetMouse(&where, &buttons);
	if (buttons & B_SECONDARY_MOUSE_BUTTON)
	{
		uint32 flags = Window()->Flags();
		flags ^= B_NO_SERVER_SIDE_WINDOW_MODIFIERS;
		Window()->SetFlags(flags);
	}
	else
	{
		++fNumClicks;
	}
	
	Invalidate();
	UnlockLooper();
}


/*
void c------------------------------() {}
*/

bool MainWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

void MainWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case B_KEY_DOWN:
			//be_app->PostMessage(B_QUIT_REQUESTED);
		break;
		
		default:
			BWindow::MessageReceived(msg);
		break;
	}	
}





